from collections import deque

from log import log


class Agenda(deque):
    def __init__(self, edges=None):
        super().__init__()
        self.edge_set = set()
        if edges is not None:
            for edge in edges:
                self.append(edge)

    def append(self, edge):
        if edge in self.edge_set:
            log.warning('duplicate edge %s', edge)
        else:
            super().append(edge)
            self.edge_set.add(edge)

    def popleft(self):
        edge = super().popleft()
        self.edge_set.remove(edge)
        return edge

    def edge_exists(self, edge):
        return edge in self.edge_set
